//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 2.6.7, s. 65
//---------------------------------------------------------------
public class PikkuVarasto2 {

  // toteutuksen tietorakenteet:

  private double maara;  // tuotteen mr  >= 0
  private String tuote;  // tuotteen nimi

  // ----- konstruktorit: -----------

  public PikkuVarasto2() {
    this.maara = 0.0;
    this.tuote = "(nimetn)";
  }

  public PikkuVarasto2(double maara, String tuote) {
    this.tuote = tuote;  // !
    if (maara > 0)
      this.maara = maara;
    else
      this.maara = 0.0;
  }

  // -----  aksessorit: --------

  public double paljonkoOn() {
    return this.maara;
  }

  public String mikaNimi() {
    return this.tuote;
  }

  public void vieVarastoon(double paljonko) {
    if (paljonko > 0)              // vain >0 kelpaa
      this.maara += paljonko;
  }

  public double otaVarastosta(double paljonko) {
    if (paljonko <= 0)                    // vain >0 kelpaa
      return 0; // lopetetaan samantien
    if (paljonko <= this.maara) {  // vhennetn varastosta
      this.maara -= paljonko;      // koko parametri
      return paljonko;
    }
    else {                   // annetaan mit voidaan!
      paljonko = this.maara; // (oikeastaan else-on turha
      this.maara = 0;        //  koska return jo lopettaa)
      return paljonko;
    }
  }

  // -- muita tykaluja PikkuVarasto2-olioiden ksittelyyn:

  public String toString() {  // varastotilanne merkkijonona
    return "(" + this.tuote + ": " + this.maara + ")";
  }

  public PikkuVarasto2 summa(PikkuVarasto2 toinen) {
    return new PikkuVarasto2(this.maara + toinen.paljonkoOn(),
                            this.tuote + toinen.mikaNimi());
  }

  public PikkuVarasto2 teeKopio() {
    double maara = this.maara;
    String tuote = this.tuote;
    PikkuVarasto2 uusi = new PikkuVarasto2(maara, tuote);
    return uusi;
    // tai lyhyemmin:
    //   return new PikkuVarasto2(this.maara, this.tuote),

  }
  // ..
}
