//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 2.6.6, s. 60
//---------------------------------------------------------------
public class PikkuVarastoTesti {
  public static void main(String[] args) {

    PikkuVarasto mehua =  new PikkuVarasto(10, "Mehu");
    PikkuVarasto olutta = new PikkuVarasto(123.4, "Olut");
    PikkuVarasto bensaa = new PikkuVarasto(90.1, "Bensa");

    // Koska luokkaan on mritelty toString-metodi,
    // muuttujien arvoja voidaan tulostaa sellaisenaan:

    System.out.println(mehua);
    System.out.println(olutta);
    System.out.println(bensaa);

/* TULOSTUS:
(Mehu: 10.0)
(Olut: 123.4)
(Bensa: 90.1)
---------------------------------------------------- */
// parametriton konstruktori:

    PikkuVarasto a = new PikkuVarasto();
    System.out.println(a);

/* TULOSTUS:
((nimetn): 0.0)
---------------------------------------------------- */
// viitteen kopiointi:

    PikkuVarasto b = mehua;
    System.out.println("" + b + mehua);

/* TULOSTUS:
(Mehu: 10.0)(Mehu: 10.0)
---------------------------------------------------- */
  // kasvatetaan b:t, mys muuttuja mehua kasvaa:

    b.vieVarastoon(25);
    System.out.println("" + b + mehua);

/* TULOSTUS:
(Mehu: 35.0)(Mehu: 35.0)
---------------------------------------------------- */
// testataan metodeita paljonkoOn() ja mikaNimi()

    System.out.println("Muuttuja bensaa:" + bensaa + ", mr="
                       + bensaa.paljonkoOn() + ", nimi="
                       + bensaa.mikaNimi());

/* TULOSTUS:
Muuttuja bensaa:(Bensa: 90.1), mr=90.1, nimi=Bensa
---------------------------------------------------- */
// varastoon vienti:

    System.out.println(bensaa);
    bensaa.vieVarastoon(27.4);
    System.out.println(bensaa);
    bensaa.vieVarastoon(-34.1);
    System.out.println(bensaa);

/* TULOSTUS:
(Bensa: 90.1)
(Bensa: 117.5)
(Bensa: 117.5)
---------------------------------------------------- */
// varastosta ottaminen:

    System.out.println(olutta);
    double saatiin = olutta.otaVarastosta(10.2);
    System.out.println("Saatiin " + saatiin + ", tilanne: "+olutta);
    saatiin = olutta.otaVarastosta(-78.8);
    System.out.println("Saatiin " + saatiin + ", tilanne: "+olutta);
    saatiin = olutta.otaVarastosta(175.5);
    System.out.println("Saatiin " + saatiin + ", tilanne: "+olutta);

/* TULOSTUS:
(Olut: 123.4)
Saatiin 10.2, tilanne: (Olut: 113.2)
Saatiin 0.0, tilanne: (Olut: 113.2)
Saatiin 113.2, tilanne: (Olut: 0.0)
---------------------------------------------------- */
// summan laskenta:

    olutta.vieVarastoon(432.1);
    PikkuVarasto c = mehua.summa(olutta);
    System.out.println("" + mehua + olutta + c);

    PikkuVarasto d = c.summa(bensaa);
    System.out.println("" + c + bensaa + d);

    d = d.summa(bensaa.summa(mehua));
    System.out.println(d);

/* TULOSTUS:
(Mehu: 35.0)(Olut: 432.1)(MehuOlut: 467.1)
(MehuOlut: 467.1)(Bensa: 117.5)(MehuOlutBensa: 584.6)
(MehuOlutBensaBensaMehu: 737.1)
---------------------------------------------------- */
  }
}
