//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 2.6.6, s. 59
//---------------------------------------------------------------
public class PikkuVarasto {

  // toteutuksen tietorakenteet:

  private double maara;  // tuotteen mr  >= 0
  private String tuote;  // tuotteen nimi

  // ----- konstruktorit: -----------

  public PikkuVarasto() {
    this.maara = 0.0;
    this.tuote = "(nimetn)";
  }

  public PikkuVarasto(double maara, String tuote) {
    this.tuote = tuote;  // !
    if (maara > 0)
      this.maara = maara;
    else
      this.maara = 0.0;
  }

  // -----  aksessorit: --------

  public double paljonkoOn() {
    return this.maara;
  }

  public String mikaNimi() {
    return this.tuote;
  }

  public void vieVarastoon(double paljonko) {
    if (paljonko > 0)              // vain >0 kelpaa
      this.maara += paljonko;
  }

  public double otaVarastosta(double paljonko) {
    if (paljonko <= 0)                    // vain >0 kelpaa
      return 0; // lopetetaan samantien
    if (paljonko <= this.maara) {  // vhennetn varastosta
      this.maara -= paljonko;      // koko parametri
      return paljonko;
    }
    else {                   // annetaan mit voidaan!
      paljonko = this.maara; // (oikeastaan else-on turha
      this.maara = 0;        //  koska return jo lopettaa)
      return paljonko;
    }
  }

  // -- muita tykaluja PikkuVarasto-olioiden ksittelyyn:

  public String toString() {  // varastotilanne merkkijonona
    return "(" + this.tuote + ": " + this.maara + ")";
  }

  public PikkuVarasto summa(PikkuVarasto toinen) {
    return new PikkuVarasto(this.maara + toinen.paljonkoOn(),
                            this.tuote + toinen.mikaNimi());
  }
  // ...
}
