//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 4.2.5, s. 148
//---------------------------------------------------------------
public class KaikkiMukaan {

 //-- MUUTTUJIA ELI KENTTI -----------------------------

  int i=1;       // joka ilmentymll on oma i

  static int j;  // luokkamuuttuja eli staattinen kentt:
                 // j on yhteinen kaikille ilmentymille

  private int k; // piilossa pidetty kentt

  static final int VAKIO=77; // vakio

  static int[] taulu;

  int[][] matriisi = {{1,2},{3,4}};

//--   KONSTRUKTOREITA -----------------------------------

  KaikkiMukaan() {
    i+=2; j=3+VAKIO;
  }
  KaikkiMukaan(int i) {  // kuormittaminen
    this();              // konstruktorin kutsu
    this.i=i+2*this.i;   // viittaus olion i:hin
    j=3*i;
  }

 //-- METODEITA -----------------------------------------

  int laske(int x) {       // arvon palauttava, "funktio"
    return i+j+x+VAKIO;
  }
  void tulosta(int x) {    // "arvoton", "proseduuri"
    System.out.println(i+x);
  }
  static void tulostaJ() { // staattinen metodi
    ++j;                   // eli luokkametodi
    System.out.println(j);
    //  ++i; ei ole luvallinen
    //      "Can't make a static reference to nonstatic variable"
  }

 //-- AKSESSOREITA ------------

  public void asetaK(int x) { // piilotetun asetus
    k = x;
  }
  public int mitaKOn() {      // piilotetun kysely
    return k;
  }

  //-- STAATTINEN ALUSTUSLOHKO -----------------

  static {
    taulu = new int[8];
    for (int i=0; i<taulu.length; ++i)
      taulu[i] = i*i;
  }

 //-- LOPETUSMETODI ---------------------

  protected void finalize() throws Throwable {
    super.finalize();
    // ...
  }

 //-- POHJELMAMETODI ----------------

  public static void main(String[] a) {
    KaikkiMukaan x = new KaikkiMukaan();
    KaikkiMukaan y = new KaikkiMukaan(7);

    System.out.println(x.i+" "+y.i);

    System.out.println(x.taulu[5]+" "+      // sama taulu
                       y.taulu[6]+" "+      // koska static
                       KaikkiMukaan.taulu[7]);

    x.matriisi[0][1] = y.matriisi[1][0];   // eri matriisi
    System.out.println(x.matriisi[0][1]+" "+ y.matriisi[0][1]);

    System.out.println("B! "+x.laske(5)+" "+y.laske(6));

    x.tulosta(7); y.tulosta(8);      // ilmentymmetodeja

    x.asetaK(89);                    // suojatun kentn
    System.out.println(x.mitaKOn()); // kytt operaatioin

    x.tulostaJ(); y.tulostaJ(); // luokkametodi:
    tulostaJ();                 // kaikki 4 tarkoittavat samaa,
    KaikkiMukaan.tulostaJ();    // viimeinen tapa on kaunein!

    // tulosta(8); //ei ole luvallinen
    //      "Can't make static reference to method ..."

    // KaikkiMukaan.tulosta(8);  //ei ole luvallinen
    //      "Can't make static reference to method ..."
  }
}
