//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 4.3.4, s. 158
// TM ON SE OLIOHENKINEN VERSIO
// Testiohjelma on tss hakemistossa nimell TestaaLista.java
//---------------------------------------------------------------
public class Lista {   // Tunnussolmullinen linkitetty lista

  private int tieto;
  private Lista linkki;

  public Lista() {    // Luodaan pelkk tunnussolmu,
    linkki = null;    // kyttjlle siis "tyhj lista"
  }

  public void vieAlkuun(int tieto) {
    Lista uusi = new Lista();      // this on aina listan
    uusi.tieto = tieto;            // tunnussolmu
    uusi.linkki = this.linkki;
    this.linkki = uusi;
  }

  public void vieLoppuun(int tieto) {
    Lista uusi = new Lista();
    uusi.tieto = tieto;
    uusi.linkki = null;
    Lista p = this;   // etsitn loppu
    while (p.linkki != null)
      p = p.linkki;
    p.linkki = uusi; // liitetn listan loppuun
   }

  public int pituus() {
    int lkm=0;
    Lista p=this.linkki;   // 1. varsinainen alkio
    while (p != null) {
      ++lkm;
      p = p.linkki;
    }
    return lkm;
  }

  public int monentenako(int x) {  // arvo -1, 1, 2, ...
    int lkm = 0;
    Lista p=this.linkki;   // 1. varsinainen alkio
    while (p != null) {
      ++lkm;
      if (p.tieto==x)
        return lkm;
      p = p.linkki;
    }
    return -1;
  }

  public void liita(Lista loppu) {
    // etsitn viimeinen:
    Lista p=this.linkki;
    if (p==null)  // saava lista on tyhj
      this.linkki = loppu.linkki;
    else {
      while (p.linkki != null)
        p = p.linkki;
      // linkitetn:
      p.linkki = loppu.linkki;
    }
  }

  public Lista kopio() {
    Lista uusi = new Lista(); // uuden tunnussolmu
    Lista q = uusi; // osoitaa viimeisimpn luotuun solmuun
    Lista p = this.linkki;
    while (p != null) {
      q.linkki = new Lista();
      q = q.linkki;
      q.tieto = p.tieto;
      p = p.linkki;
    }
    return uusi;
  }

  public String toString() {  // tss kvisi hullusti jos
    Lista p=this.linkki;      // listassa jonkin ohjelmointi-
    String mjono="";          // virheen takia olisi sykli
    while (p != null) {
      mjono += "-> (" + p.tieto + ") ";  // nuoli ja arvo
      p = p.linkki;
    }
    return mjono+"-||";  // lopun tyhj linkki
  }
}
