//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappaleet 6.2.2 - 6.2.5, s. 230 - 234
//---------------------------------------------------------------
import java.awt.*;
import java.awt.event.*;

public class Piirtoa extends Frame {  // sovellus

  private Alusta paperi = new Alusta();

  public Piirtoa() {
    paperi.setBackground(Color.white);
    paperi.setSize(319,558);
    add(paperi);
    addWindowListener(new HoiteleIkkunanSulkeminen());
  }

  public static void main(String args[]) {
    Piirtoa ikkuna = new Piirtoa();
    ikkuna.setTitle("Piirtoa");
    ikkuna.pack();
    ikkuna.setVisible(true);
  }
}

class Alusta extends Canvas {  // piirtoalusta

  private int lkm=1; // ks. kpl 6.2.3

  public void paint(Graphics g) {
    // ... ks. kappaleet 6.2.3 - 6.2.5

    // s. 230
    g.drawString("Teksti!", 10, 20);

    // s. 232
    Font kirjasin = new Font("Serif", Font.BOLD+Font.ITALIC, 14);
    g.setFont(kirjasin);
    g.drawString("Kaunista teksti!", 20, 40);

    // s. 232
    kirjasin = new Font("Serif", Font.PLAIN, 12);
    g.setFont(kirjasin);
    g.drawString("Maalauskerta numero: "+lkm, 20,60);
    ++lkm; 

    // s. 232
    g.drawLine(15,90,250,150);
    g.drawString("(15,90)",1,85);
    g.drawString("(250,150)",225,165);

    // arvottu jana, siis aina erilainen
    g.drawRect(20,140,80,60);
    int alkux  = 20 +  (int)(Math.random()*80);
    int alkuy  = 140 + (int)(Math.random()*60);
    int loppux = 20 +  (int)(Math.random()*80);
    int loppuy = 140 + (int)(Math.random()*60);
    g.drawLine(alkux,alkuy,loppux,loppuy);

    int[] xPisteet = {5,    20,  80, 100};
    int[] yPisteet = {350, 380, 340, 360};
    int pisteLkm = xPisteet.length;
    g.drawPolygon(xPisteet, yPisteet, pisteLkm);

    // s. 233

    int x, y;
    g.setColor(Color.blue);
    g.drawRect(10,220,299,99);
    g.drawString("Sini:",13,2322);
    g.drawLine(10,270,309,270);
    for (x=11; x<309; ++x)
      g.drawLine(x, (270+(int)(Math.sin(x/10.0)*30)),
                 x, (270+(int)(Math.sin(x/10.0)*30)));

    g.setColor(Color.black);

    int nurkkaX=120, nurkkaY=330;

    g.drawRect(nurkkaX ,nurkkaY, 139, 139);

    g.setColor(Color.blue);
    g.fillRect(nurkkaX+10,nurkkaY+10, 20, 20);

    g.setColor(Color.green);
    g.fillRect(nurkkaX+30,nurkkaY+30, 20, 20);

    g.setColor(Color.orange);
    g.fillRect(nurkkaX+50,nurkkaY+50, 20, 20);

    g.setColor(Color.pink);
    g.fillRect(nurkkaX+70,nurkkaY+70, 20,20);

    g.setColor(Color.red);
    g.fillRect(nurkkaX+90,nurkkaY+90, 20, 20);

    g.setColor(Color.yellow);
    g.fillRect(nurkkaX+110,nurkkaY+110, 20, 20);

    int rr,gg,bb; // RGB vrikolmikko

    bb = (int)(Math.random()*256);

    for (rr=0; rr<100; rr+=1)
      for (gg=0; gg<100; gg+=1) {
        Color vari = new Color(255-rr,255-gg,bb);
        g.setColor(vari);
        g.fillRect(10+rr,450+gg, 1,1);
      }

  }
}
