//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 6.4.2, s. 241
//---------------------------------------------------------------
////////////////////////////////////////////// Arto Wikla 1998 ////////
//
//              Luokka Laskuri: toteuttaa ylspinlaskurin.
//
//   Konstruktori:
//
// public Laskuri(int raja)
// luo Laskurin joka aloittaa nollasta ja jonka viimeinen sallittu arvo
// annetaan parametrina. Jos parametri on negatiivinen, luodaan Laskuri,
// jonka viimeinen sallittu arvo on nolla
//
//   Aksessorit:
//
// public int mikaArvo()
// palauttaa Laskurin arvon.
//
// public boolean lopussa()
// palauttaa tiedon siit, onko laskurin arvo jo saavuttanut ylrajan,
// arvo on true, jos ylraja on saavutettu
//
//   Operaatiot:
//
// public void kasvata()
// kasvattaa Laskurin arvoa, jos ylrajaa ei ole saavutettu.
//
// public void nollaa()
// nollaa Laskurin arvon.
//
//////////////////////////////////////////////////////////////////////

public class Laskuri {

  // tietorakenteen toteutuksen muuttujat:

  private final int YLARAJA;  // konstruoitavan laskurin viimeinen arvo
  private int arvo;           // laskurin arvo 0, 1, 2, ..., YLARAJA

  // Konstruktori:

  public Laskuri(int raja) {
    arvo = 0;
    if (raja > 0)
      YLARAJA = raja;
    else
      YLARAJA = 0;
  }

  // Aksessorit:

  public int mikaArvo() { return arvo; }
  public boolean lopussa() { return arvo >= YLARAJA; }

  // Operaatiot:

  public void kasvata() {
    if (!lopussa()) {
      ++arvo;
    }
  }

  public void nollaa() {
    arvo = 0;
  }
}
