//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 6.4.4, s. 245
// Esimerkit on nimetty tss Laskurisovellus1 - Laskurisovellus4
//---------------------------------------------------------------
//////////////////////////////////////////// Arto Wikla 1998 /////////
//
// Luokka Laskurisovellus2 tarjoaa kyttjlle laskurin, joka laskee
// nappulan painamisia arvoilla 1, ..., 10. Ylrajaa on helppo muuttaa,
// ks. ohjelman alussa oleva vakio LASKURIN\_KOKO.
//
// Sovellus tarjoaa mys mahdollisuuden uudelleenaloitukseen eli
// laskurin nollaamiseen.
//
// Sovellus kytt laskurina abstraktin tietotyypin Laskuri tarjoamia
// vlineit. Ks. rajapinnan mrittely tiedoston Laskuri.java alussa.
//
// Knnsyksikn lopussa on luokka HoiteleIkkunanSulkeminen,
// ks. luku 6.1.2.
//
//////////////////////////////////////////////////////////////////////
import java.awt.*;
import java.awt.event.*;

public class Laskurisovellus2 extends Frame
                              implements ActionListener {

  private final int LASKURIN_KOKO = 10; // laskurin viimeinen arvo

  private Laskuri laskuri; // muuttuja abstraktille tietorakenteelle

  // kyttliittymn elementit:

  private TextField laskurinArvo = new TextField(5);
  private Button kasvata = new Button("kasvata");
  private Button nollaa  = new Button("aloita alusta");
  private Button lopeta  = new Button("lopeta");

  //----- sovelluksen konstruointi: ----//

  public Laskurisovellus2() {

    laskuri = new Laskuri(LASKURIN_KOKO);  // tietorakenteen luonti

    // laskurinArvo-muuttujan alustus:

    laskurinArvo.setText("ALUSSA!");
    laskurinArvo.setEditable(false);

    // tapahtumankuuntelijoiden asettaminen:

    kasvata.addActionListener(this);
    nollaa.addActionListener(this);
    lopeta.addActionListener(this);

    // nkymn layoutin luonti:

    add("North", laskurinArvo);
    add("West", kasvata);
    add("East", nollaa);
    add("South", lopeta);

    // ikkunan sulkemisen kuuntelijan asettaminen:

    addWindowListener(new HoiteleIkkunanSulkeminen());
  }

  //----- tapahtumanksittelij: -----//

  public void actionPerformed(ActionEvent tapahtuma) {
    Object aiheuttaja = tapahtuma.getSource();

    if (aiheuttaja == kasvata)
      kasvatus();
    else if (aiheuttaja == nollaa)
      nollaus();
    else if (aiheuttaja == lopeta)
      lopetus();
  }

  //----- tapahtumaoperaatiot: -----//
  // (kytetn abstraktin tietotyypin Laskuri tarjoamia operaatioita)

  private void kasvatus() {
    if (!laskuri.lopussa()) {
      laskuri.kasvata();
      laskurinArvo.setText(""+laskuri.mikaArvo());
    }
    else
      laskurinArvo.setText("LOPPU!");
  }

  private void nollaus() {
    laskuri.nollaa();
    laskurinArvo.setText("ALUSSA!");
  }

  private void lopetus() {
    System.exit(0);  // ikkunan sulkeminen
  }

  //----- sovelluksen pohjelma: -----//

  public static void main(String[] args) {
    Laskurisovellus2 ikkuna = new Laskurisovellus2();
    ikkuna.setTitle(ikkuna.LASKURIN_KOKO+"-laskuri");
    ikkuna.pack();
    ikkuna.setVisible(true);
  }
}

//----- ikkunan sulkemisen hoitelu: -----//

class HoiteleIkkunanSulkeminen extends WindowAdapter {
  public void windowClosing(WindowEvent tapahtuma) {
    System.exit(0);  // ikkunan sulkeminen
  }
}
