//---------------------------------------------------------------
// Arto Wikla: Ohjelmoinnin perusteet Java-kielell, OtaDATA 1998
// kappale 6.4.6, s. 247
// Esimerkit on nimetty tss Laskurisovellus1 - Laskurisovellus4
//---------------------------------------------------------------
//////////////////////////////////////////// Arto Wikla 1998 /////////
//
// Luokka Laskurisovellus4 tarjoaa kyttjlle laskurin, joka laskee
// nappulan painamisia arvoilla 1, ..., 10. Ylrajaa on helppo muuttaa,
// ks. ohjelman alussa oleva vakio LASKURIN_KOKO.
//
// Sovellus tarjoaa mys mahdollisuuden uudelleenaloitukseen eli
// laskurin nollaamiseen.
//
// Sovellus kytt laskurina abstraktin tietotyypin Laskuri tarjoamia
// vlineit. Ks. rajapinnan mrittely tiedoston Laskuri.java alussa.
//
//////////////////////////////////////////////////////////////////////
import java.awt.*;
import java.awt.event.*;

public class Laskurisovellus4 extends Frame {

  private final int LASKURIN_KOKO = 10; // laskurin viimeinen arvo

  private Laskuri laskuri; // muuttuja abstraktille tietorakenteelle

  // kyttliittymn elementtikentt:

  private TextField laskurinArvo;
  private Button kasvata;
  private Button nollaa;
  private Button lopeta;

  //----- sovelluksen konstruointi: ----//

  public Laskurisovellus4() {

    laskuri = new Laskuri(LASKURIN_KOKO);  // tietorakenteen luonti

    // kyttliittymn elementtien arvot:

    laskurinArvo = new TextField(5);
    laskurinArvo.setText("ALUSSA!");
    laskurinArvo.setEditable(false);

    kasvata = new Button("kasvata");
    nollaa  = new Button("aloita alusta");
    lopeta  = new Button("lopeta");

    // tapahtumankuuntelijoiden asettaminen ja tapahtumien ksittely:

    kasvata.addActionListener(
      new ActionListener () {
        public void actionPerformed(ActionEvent tapahtuma) {
          if (!laskuri.lopussa()) {
            laskuri.kasvata();
            laskurinArvo.setText(""+laskuri.mikaArvo());
          }
          else
            laskurinArvo.setText("LOPPU!");

        }
      }
    );

    nollaa.addActionListener(
      new ActionListener () {
        public void actionPerformed(ActionEvent tapahtuma) {
          laskuri.nollaa();
          laskurinArvo.setText("ALUSSA!");
        }
      }
    );

    lopeta.addActionListener(
      new ActionListener () {
        public void actionPerformed(ActionEvent tapahtuma) {
          System.exit(0);  // ikkunan sulkeminen
        }
      }
    );

    // nkymn layoutin luonti:

    add("North", laskurinArvo);
    add("West", kasvata);
    add("East", nollaa);
    add("South", lopeta);

    // ikkunan sulkemisen kuuntelijan asettaminen ja sulkemisen ksittely:

    addWindowListener(
      new WindowAdapter () {
        public void windowClosing(WindowEvent tapahtuma) {
           System.exit(0);  // ikkunan sulkeminen
        }
      }
    );

  }

  //----- sovelluksen pohjelma: -----//

  public static void main(String[] args) {
    Laskurisovellus4 ikkuna = new Laskurisovellus4();
    ikkuna.setTitle(ikkuna.LASKURIN_KOKO+"-laskuri");
    ikkuna.pack();
    ikkuna.setVisible(true);
  }
}
